﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace WindowsFormsApplication1
{

    public partial class Form1 : Form
    {

        DataTable dataTable; // matrix of data read from file
        long start_iTOW = 9999999999999; // initialized to a very high value (first GPS time of week)
        long end_iTOW = 0; // initialized to a very small value (last GPS time of week)
        bool loaded_file = false; // file has been not loaded yet

        public Form1()
        {
            InitializeComponent();
        }

        public String NomeDati(int colonna)
        {
            switch (colonna)
            {
                case 0:
                    return "EngSpeed[rpm]";
                case 1:
                    return "InjTime[us]";
                case 2:
                    return "Throttle[%]";
                case 3:
                    return "Speed[km/h]";
                case 4:
                    return "Yaw[deg]";
                case 5:
                    return "Pitch[deg]";
                case 6:
                    return "Roll[deg]";
                case 7:
                    return "iTOW[s]";
                case 8:
                    return "Latitude";
                case 9:
                    return "Longitude";
                case 10:
                    return "Height[m]";
                case 11:
                    return "DataType";
                default:
                    return "Not known data";
            }
        }

        public void RicaricaGrafici()
        {
            if (!loaded_file) return;

            // Searches for starting position
            int start_row = 0;
            int end_row = 0;
            int i = 0;
            while ((long)Convert.ToDouble(dataTable.Rows[i][7]) < numericUpDown4.Value)
            {
                i++;
            }
            start_row = i;
            i = 0;
            while ((long)Convert.ToDouble(dataTable.Rows[i][7]) < numericUpDown5.Value)
            {
                i++;
            }
            end_row = i;
            this.chart1.Series["Series1"].Points.Clear();
            this.chart2.Series["Series1"].Points.Clear();
            this.chart3.Series["Series1"].Points.Clear();
            for (i = start_row; i <= end_row; i++)
            {
                this.chart1.Series["Series1"].Points.AddXY(dataTable.Rows[i][7], dataTable.Rows[i][((int)this.numericUpDown1.Value)]);
                this.chart2.Series["Series1"].Points.AddXY(dataTable.Rows[i][7], dataTable.Rows[i][((int)this.numericUpDown2.Value)]);
                this.chart3.Series["Series1"].Points.AddXY(dataTable.Rows[i][7], dataTable.Rows[i][((int)this.numericUpDown3.Value)]);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string filePath = textBox1.Text;
            StreamReader streamReader;
            try { 
                streamReader = new StreamReader(filePath);
                dataTable = new DataTable();
                dataTable.Columns.Add("EngSpeed[rpm]");
                dataTable.Columns.Add("InjTime[us]");
                dataTable.Columns.Add("Throttle[%]");
                dataTable.Columns.Add("Speed[km/h]");
                dataTable.Columns.Add("Yaw[deg]");
                dataTable.Columns.Add("Pitch[deg]");
                dataTable.Columns.Add("Roll[deg]");
                dataTable.Columns.Add("iTOW[s]");
                dataTable.Columns.Add("Latitude");
                dataTable.Columns.Add("Longitude");
                dataTable.Columns.Add("Height[m]");
                dataTable.Columns.Add("DataType");
                string[] totalData = new string[File.ReadAllLines(filePath).Length];
                totalData = streamReader.ReadLine().Split(',');
                while (!streamReader.EndOfStream)
                {
                    totalData = streamReader.ReadLine().Split(',');
                    dataTable.Rows.Add(totalData[0], totalData[1], totalData[2], totalData[3], totalData[4], totalData[5], totalData[6], totalData[7], totalData[8], totalData[9], totalData[10], totalData[11]);
                    long iTOW_now = (long)Convert.ToDouble(totalData[7]);
                    if (iTOW_now < start_iTOW) start_iTOW = iTOW_now; // updates start time
                    if (iTOW_now > end_iTOW) end_iTOW = iTOW_now; // updates end time
                }
                numericUpDown4.Minimum = start_iTOW;
                numericUpDown4.Maximum = end_iTOW;
                numericUpDown4.Value = start_iTOW;
                numericUpDown5.Minimum = start_iTOW;
                numericUpDown5.Maximum = end_iTOW;
                numericUpDown5.Value = end_iTOW;
                dataGridView1.DataSource = dataTable;
                loaded_file = true;
                RicaricaGrafici();
                label4.Text = "Data imported";
            }
            catch
            {
                label4.Text = "File not found";
            }
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            this.label1.Text = NomeDati((int)this.numericUpDown1.Value);
            RicaricaGrafici();
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            this.label2.Text = NomeDati((int)this.numericUpDown2.Value);
            RicaricaGrafici();
        }

        private void numericUpDown3_ValueChanged(object sender, EventArgs e)
        {
            this.label3.Text = NomeDati((int)this.numericUpDown3.Value);
            RicaricaGrafici();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.label1.Text = NomeDati((int)this.numericUpDown1.Value);
            this.label2.Text = NomeDati((int)this.numericUpDown2.Value);
            this.label3.Text = NomeDati((int)this.numericUpDown3.Value);
        }

        private void numericUpDown4_ValueChanged(object sender, EventArgs e)
        {
            RicaricaGrafici();
        }

        private void numericUpDown5_ValueChanged(object sender, EventArgs e)
        {
            RicaricaGrafici();
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void panel2_Paint(object sender, PaintEventArgs e)
        {

        }
    }
}
